using System;

namespace Kvalifikacije_11_27
{
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());

            string[] s = Console.ReadLine().Split();
            int o = int.Parse(s[0]);
            int a = int.Parse(s[1]);
            int b = int.Parse(s[2]);
            int ab = int.Parse(s[3]);

            int[,] pac = new int[n, 4];

            int o1 = 0;
            int a1 = 0;
            int b1 = 0;
            int ab1 = 0;

            int br = 0;
            string kg;
            int bp;
            string[] u;
            for (int i = 0; i < n; i++)
            {
                u = Console.ReadLine().Split();
                kg = u[0];
                bp = int.Parse(u[1]);

                if (kg == "O")
                {
                    while (bp > 0 && o > 0)
                    {
                        o--;
                        o1++;
                        bp--;
                    }
                }
                else if (kg == "A")
                {
                    while (bp > 0 && (a > 0 || o > 0))
                    {
                        if (a > 0)
                        {
                            a--;
                            a1++;
                        }
                        else if (o > 0)
                        {
                            o--;
                            o1++;
                        }

                        bp--;
                    }
                }
                else if (kg == "B")
                {
                    while (bp > 0 && (b > 0 || o > 0))
                    {
                        if (b > 0)
                        {
                            b--;
                            b1++;
                        }
                        else if (o > 0)
                        {
                            o--;
                            o1++;
                        }

                        bp--;
                    }
                }
                else if (kg == "AB")
                {
                    while (bp > 0 && (a > 0 || b > 0 || o > 0))
                    {
                        if (ab > 0)
                        {
                            ab--;
                            ab1++;
                        }
                        else if (a > 0)
                        {
                            a--;
                            a1++;
                        }
                        else if (b > 0)
                        {
                            b--;
                            b1++;
                        }
                        else if (o > 0)
                        {
                            o--;
                            o1++;
                        }

                        bp--;
                    }
                }
                pac[i, 0] = o1;
                pac[i, 1] = a1;
                pac[i, 2] = b1;
                pac[i, 3] = ab1;

                o1 = 0;
                a1 = 0;
                b1 = 0;
                ab1 = 0;

                if (bp > 0)
                    br++;

            }

            if (br > 0)
                Console.WriteLine("nemoguce");
            else
            {
                Console.WriteLine("moguce");
                for (int i = 0; i < n; i++)
                    Console.WriteLine(pac[i, 0] + " " + pac[i, 1] + " " + pac[i, 2] + " " + pac[i, 3]);
            }

        }
    }
}